#include "ExplorerWindow.h"

ExplorerWindow::ExplorerWindow(QString title, QWidget *parent):QDockWidget(title, parent),m_fileCounter(-1){
	resize(300,500);
	m_treeView = new TreeWidget();
	setWidget(m_treeView);
	m_treeView->setColumnCount(4);
	m_treeView->hideColumn(1);
	m_treeView->hideColumn(2);
	m_treeView->hideColumn(3);
	m_treeView->header()->hide();
	QObject::connect(m_treeView,SIGNAL(itemDoubleClicked(QTreeWidgetItem*,int)),this,SLOT(doubleclicked(QTreeWidgetItem*,int))); //To open a file double clicked

	//Construction of the context Menu	
	m_treeView->setContextMenuPolicy(Qt::CustomContextMenu);
	QObject::connect(m_treeView,SIGNAL(customContextMenuRequested(const QPoint&)),this,SLOT(onCustomContextMenuRequested(const QPoint&)));
	
	
}
void ExplorerWindow::resizeEvent(QResizeEvent *event){
	emit resizeExplorer(this->width());
}
void ExplorerWindow::onCustomContextMenuRequested(const QPoint& pos) {
        QTreeWidgetItem* item = m_treeView->itemAt(pos); 
		if (item && item->text(1)=="Root Item") {
            m_contextMenuRootItem = new QMenu();
			QAction *close = new QAction("Close",m_contextMenuRootItem);
			m_contextMenuRootItem->addAction(close);
			QObject::connect(close, SIGNAL(triggered()), this, SLOT(closeSlot()));
			m_contextMenuRootItem->popup(m_treeView->viewport()->mapToGlobal(pos));
        }
		

 }
void ExplorerWindow::addFile(QString fileName){

	m_fileName.push_back(fileName);
	m_fileCounter++;

	m_rootItems.push_back(new QTreeWidgetItem());
	m_rootItems[m_rootItems.size()-1]->setText(0,fileNameReduced(fileName));
	m_rootItems[m_rootItems.size()-1]->setText(1,"Root Item");
	m_rootItems[m_rootItems.size()-1]->setText(2,QString::number(m_rootItems.size()-1));
	m_rootItems[m_rootItems.size()-1]->setIcon(0,QPixmap("C:/Users/Nico/Documents/Visual Studio 2012/Projects/ImageProcessing/Win32/Debug/box.png"));
	m_treeView->addTopLevelItem(m_rootItems[m_rootItems.size()-1]);



	//Connexion
	m_file_id.push_back(Hopen(fileName.toStdString().c_str(), DFACC_READ,0));
	Vstart(m_file_id[m_file_id.size()-1]);

	//Search Items
	int32 numLones(0);
	numLones = Vlone(m_file_id[m_file_id.size()-1],NULL,numLones);
	int32 *ref_array = (int32 *) malloc(sizeof(int32) * numLones);
	
	Vlone(m_file_id[m_file_id.size()-1],ref_array,numLones);
	char name[300];

	m_itemsRootColumn.clear();
	
	for (int i(0);i<numLones;i++){
		//Vgroups of the first Column
		int32 vgroupRoot_id= Vattach(m_file_id[m_file_id.size()-1],ref_array[i],"r");
		int32 sta = Vgetname(vgroupRoot_id,name);

			m_itemsRootColumn << new QTreeWidgetItem();
			m_itemsRootColumn[i]->setIcon(0,QPixmap("C:/Users/Nico/Documents/Visual Studio 2012/Projects/ImageProcessing/Win32/Debug/iconDirectory.png"));
			m_itemsRootColumn[i]->setText(1,"Folder");
		
			m_itemsRootColumn[i]->setText(0,name);
			m_rootItems[m_rootItems.size()-1]->addChild(m_itemsRootColumn[i]);

			searchVGroups(vgroupRoot_id,m_itemsRootColumn[i]);
			searchDatas(vgroupRoot_id,m_itemsRootColumn[i]);

		
	}
	m_treeView->expandAll();

	
}
void ExplorerWindow::searchVGroups(int32 vgroup_id,QTreeWidgetItem* &vgroupContener){
	QVector<QTreeWidgetItem*> items;

	uintn n_vgrps = Vgetvgroups(vgroup_id,0,0,NULL);
	uint16 *ref_array = (uint16 *)HDmalloc(sizeof(uint16)*n_vgrps);
	int32 c = Vgetvgroups(vgroup_id,0,n_vgrps,ref_array);

	for ( int j(0);j<n_vgrps;j++){
		
		int32 vgroup_id = Vattach(m_file_id[m_file_id.size()-1],ref_array[j],"r");			
		char vsnameGrps[VSNAMELENMAX];	
		Vgetname(vgroup_id, vsnameGrps);
		items << new QTreeWidgetItem();
		items[j]->setText(0,vsnameGrps);
		items[j]->setText(1,"Folder");
		items[j]->setIcon(0,QPixmap("C:/Users/Nico/Documents/Visual Studio 2012/Projects/ImageProcessing/Win32/Debug/iconDirectory.png"));
		vgroupContener->addChild(items[j]);

		
		searchVGroups(vgroup_id,items[j]);
		searchDatas(vgroup_id,items[j]);

	}
}
void ExplorerWindow::searchDatas(int32 vgroup_id, QTreeWidgetItem* &vgroupContener){//Find each type of file : SDS
	QVector<QTreeWidgetItem*> items;
	int32 sd_id;
	int32 n_vsds = Vntagrefs(vgroup_id);
	int32 obj_index(0), obj_tag,obj_ref;
	int32 rank, dim_sizes, data_type,n_attrs;
	int i(0);
	char name[VSNAMELENMAX];	

	for (obj_index = 0; obj_index < n_vsds; obj_index++){
		Vgettagref (vgroup_id, obj_index, &obj_tag, &obj_ref);	
		if (!Visvg (vgroup_id, obj_ref)){ //If it's not a vgroup
			int u = VSattach(m_file_id[m_file_id.size()-1],obj_ref,"r");
			if(u==-1){	
				sd_id = SDstart(m_fileName[m_fileName.size()-1].toStdString().c_str(), DFACC_READ);
				int32 sd_index = SDreftoindex(sd_id,obj_ref);
				int32 sds_id = SDselect(sd_id, sd_index);
			
				int32 a = SDgetinfo(sds_id, name, &rank, &dim_sizes, &data_type,&n_attrs);
				items << new QTreeWidgetItem();
				items[i]->setText(0,name);
				items[i]->setIcon(0,QPixmap("C:/Users/Nico/Documents/Visual Studio 2012/Projects/ImageProcessing/Win32/Debug/iconSD.png"));
				items[i]->setText(1,"SDS");
				items[i]->setText(2,QString::number(sd_index));
				items[i]->setText(3,m_fileName[m_fileName.size()-1]);
				vgroupContener->addChild(items[i]);
			}
		}					
	i++;
	}

}
QString ExplorerWindow::fileNameReduced(QString fileName){
	QString fileNameReduced;
	int i(fileName.size());
	while(fileName[i]!='/'){
		i--;
	}
	int k(i);
	for (int j(0);j<fileName.size()-i;j++){
		k++;
		fileNameReduced[j] = fileName[k];
	}
	return fileNameReduced;

}
void ExplorerWindow::closeSlot()//Close the file
{
	int index = m_treeView->selectedItems()[0]->text(2).toInt();
	m_rootItems.remove(index);
	delete m_treeView->selectedItems()[0];
	for (int i(0);i<m_rootItems.size();i++){
		m_rootItems[i]->setText(2,QString::number(i));
	}

	emit closeFile(index);

}
void ExplorerWindow::doubleclicked(QTreeWidgetItem *item, int column){

	int indexFile;

if (item->text(1)=="SDS"){ //SDS


		int32 sd_id = SDstart (item->text(3).toStdString().c_str(), DFACC_READ); //Attach to fileName
		int32 sds_id = SDselect(sd_id,item->text(2).toInt());//attach to SDS
		char sds_name[50];
		int32 rank,sds_type,n_atr;
		int32 dimsize[2];
		int32 start[2], edges[2];
		data = 0;


		SDgetinfo(sds_id,sds_name,&rank,dimsize,&sds_type,&n_atr);


		openSDS(item,column);


		emit SDSSelectionned(data,dimsize,item->text(2).toInt(),item->text(3),item->text(0));
		delete [] data;



	}

}
void ExplorerWindow::openSDS(QTreeWidgetItem* item,int column){
	
		int32 sd_id = SDstart (item->text(3).toStdString().c_str(), DFACC_READ);
		int32 sds_id = SDselect(sd_id,item->text(2).toInt());
		char sds_name[50];
		int32 rank,sds_type,n_atr;
		int32 dimsize[2];
		int32 start[2], edges[2];
		uint8 **data8 = 0;
		int16 **data16 = 0;

	

		SDgetinfo(sds_id,sds_name,&rank,dimsize,&sds_type,&n_atr);


		data = new uint16*[dimsize[0]];
			std::fill_n( data, dimsize[0], static_cast<uint16*>( 0 ) );
			for (int i(0);i<dimsize[0];i++){
				data[i] = new uint16[dimsize[1]];
				std::fill_n( data[i], dimsize[1], static_cast<uint16>( 0 ) );
			}

		switch (sds_type){
		case 22: //The data is a table of 16 integer.
			data16 = new int16*[dimsize[0]];
			for (int i(0);i<dimsize[0];i++){
				data16[i] = new int16[dimsize[1]];
			}
			
			start[0] = 0;
			start[1] = 0;
			edges[0] = 1;
			edges[1] = dimsize[1];
			for (int i(0);i<dimsize[0];i++){
				start[0] = i;
				int32 status = SDreaddata (sds_id, start, NULL, edges, data16[i]);	
			
			}
			for (int i(0);i<dimsize[0];i++){
				for (int j(0);j<dimsize[1];j++){
					data[i][j]=(uint16)data16[i][j]+32768;
				}
			}

			delete [] data16;
			break;

		case 21: //The data is a table of unsigned 8 bit integer

			data8 = new uint8*[dimsize[0]];
			for (int i(0);i<dimsize[0];i++){
				data8[i] = new uint8[dimsize[1]];
			}
	
		
			start[0] = 0;
			start[1] = 0;
			edges[0] = 1;
			edges[1] = dimsize[1];
			for (int i(0);i<dimsize[0];i++){
				start[0] = i;
				int32 status = SDreaddata (sds_id, start, NULL, edges, data8[i]);	
			
			}
			for (int i(0);i<dimsize[0];i++){
				for (int j(0);j<dimsize[1];j++){
					data[i][j]=(uint16)data8[i][j];
				}
			}

			delete [] data8;
			break;

		case 23 : //The data is a table of unsigned 16 bit integer	
			start[0] = 0;
			start[1] = 0;
			edges[0] = 1;
			edges[1] = dimsize[1];
			for (int i(0);i<dimsize[0];i++){
				start[0] = i;
				int32 status = SDreaddata (sds_id, start, NULL, edges, data[i]);	
			
			}


			break;
		case 6:
		case 20:
		case 25:
				QMessageBox::warning(this, "Warning", "This software doesn't support this type of file.");
			break;
		}

	}
uint16** ExplorerWindow::findItem(QString refItem,int band){
	QList<QString> ref;
	ref = refItem.split(',');
		
	QList<QTreeWidgetItem*> items;
	items = m_treeView->findItems(ref[0],Qt::MatchContains | Qt::MatchRecursive,0);
	for (int i(0);i<items.size();i++){
		if (items[i]->text(3)==ref[1]){
			openSDS(items[i],0);
		
			int32 sd_id = SDstart (items[i]->text(3).toStdString().c_str(), DFACC_READ);
			int32 sds_id = SDselect(sd_id,items[i]->text(2).toInt());
			char sds_name[50];
			int32 rank,sds_type,n_atr;
			int32 dimsize[2];

			SDgetinfo(sds_id,sds_name,&rank,dimsize,&sds_type,&n_atr);
			//emit SDSSelectionnedRGB(data,dimsize,items[i]->text(2).toInt(),items[i]->text(3),items[i]->text(0),band);
			return data;
		}
	}
}
int32* ExplorerWindow::findDimSize(QString refItem){
	QList<QString> ref;
	ref = refItem.split(',');
	
	
	QList<QTreeWidgetItem*> items;
	items = m_treeView->findItems(ref[0],Qt::MatchContains | Qt::MatchRecursive,0);


	char sds_name[50];
	int32 rank,sds_type,n_atr;
	int32 dimsize[2];



	for (int i(0);i<items.size();i++){
		if (items[i]->text(3)==ref[1]){
			int32 sd_id = SDstart (items[i]->text(3).toStdString().c_str(), DFACC_READ);
			int32 sds_id = SDselect(sd_id,items[i]->text(2).toInt());
			SDgetinfo(sds_id,sds_name,&rank,dimsize,&sds_type,&n_atr);
		}
	}
	return dimsize;

	

		
}







