#ifndef DEF_EXPLORERWINDOW
#define DEF_EXPLORERWINDOW
#include <QtWidgets>
#include "hdf.h"
#include <mfhdf.h>
#include "TreeWidget.h"

class ExplorerWindow : public QDockWidget{
Q_OBJECT
public:
	ExplorerWindow(QString title, QWidget *parent);
	void addFile(QString fileName);
	static QString fileNameReduced(QString fileName);
	void searchVGroups(int32 vgroup_id,QTreeWidgetItem* &vgroupContener);
	void searchDatas(int32 vgroup_id, QTreeWidgetItem* &vgroupContener);
	void resizeEvent(QResizeEvent *event);
	void openSDS(QTreeWidgetItem* item,int column);
	uint16** findItem(QString refItem,int band);
	int32* findDimSize(QString refItem);





public slots:
		void doubleclicked(QTreeWidgetItem* item,int column);
		void closeSlot();
		void onCustomContextMenuRequested(const QPoint& pos);
		

	signals:
		void itemSelectionned(QStringList bufferTable, QVector<QVector<int32>> datas,QString vdataName,int32 vdata_id,QString fileName);
		void SDSSelectionned(uint16 **data, int32 *dimsize,int sd_index,QString fileName,QString sdsName);
		void closeFile(int itemIndex);
		void resizeExplorer(int widthExplorer);
		void SDSSelectionnedRGB(uint16 **data, int32 *dimsize,int sd_index,QString fileName,QString sdsName,int band);
		

private:
	QVector<QString> m_fileName;
	TreeWidget *m_treeView;
	QVector<int32> m_file_id;
	QVector<QTreeWidgetItem*> m_rootItems;
	QVector<QTreeWidgetItem*> m_itemsRootColumn;
	QMenu *m_contextMenuRootItem;
	QMenu *m_contextMenuVGroup;
	QMenu *m_contextMenuVData;
	QMenu *m_contextMenuSDS;
	int m_fileCounter;
	uint16 **data;

	

};




#endif