#ifndef DEF_MAINWINDOW
#define DEF_MAINWINDOW

#include <QtWidgets>
#include "ExplorerWindow.h"
#include <opencv2/highgui/highgui.hpp>
#include <opencv/cv.h>
#include "MyGraphicsView.h"
#include "ToolsDock.h"
#include "ProcessingFunctions.h"
#include <vector>
#include "hdf.h"
#include <mfhdf.h>
//#include <math.h>
#include "OpenedFile.h"




class MainWindow : public QMainWindow{
	Q_OBJECT
public:
	MainWindow();
	void resizeEvent(QResizeEvent *event);
	int fileAlreadyOpened(QString type,int sd_index,QString fileName);

public slots:
	void openActionSlot();
	void openSDS(uint16 **data,int32 *dimsize,int sd_index,QString fileName, QString sdsName);
	void closeFileSlot(int itemIndex);
	void closeTab(int index);
	void resizeExplorerSlot(int widthExplorer);	
	void changeZoomIn(bool checked);
	void changeZoomOut(bool checked);
	void changeZoomZone(bool checked);
	void resizeToolsSlot(int widthTools);
	void contrastLuminosityModifiedSlot(int contrast,int luminosity);
	void updateSliders(int globalIndex);
	void createRGBImageSlot(QString redBand,QString greenBand,QString blueBand);
	void selectionPaternZone(bool checked);
	void textureCalculSlot(QPointF init, QPointF end);
	void selectionSearchingZone(bool checked);
	void resetMat();
	void allImageZone();
	void openActionImageSlot();
	void resetMatLBP();
	void testImageSlot();

private:
	QMdiArea *m_centralZone;
	ExplorerWindow *explorerWindow;
	ToolsDock *toolsDock;
	QMdiSubWindow *m_mainSubWindow;
	QTabWidget *m_workZoneTab;
	QVector<QString> m_fileNames;
	QAction *m_zoomInAction;
	QAction *m_zoomOutAction;
	QAction *m_zoomZoneAction;
	cv::Mat m_mat;
	QVector<QVector<double>> m_features;
	QVector<QVector<double>> m_lbpFeatures;
	QVector<OpenedFile*> m_openedFiles;
	QAction *m_testImageAction;
	QVector<QVector<double>> m_lbpFeaturesNormal;
	QVector<double*> m_featuresMean;
	QVector<double**> m_featuresMatrix;
};
#endif
