#include "MyGraphicsView.h"


MyGraphicsView::MyGraphicsView(int dimx,int dimy):m_dimx(dimx),m_dimy(dimy),m_zoomInActivated(false),m_zoomOutActivated(false),m_zoomZoneActivated(false),m_selectPaternActivated(false),m_initialization(false),m_selectSearchingZoneActivated(false)
{
	m_colors.push_back(7); //red
	m_colors.push_back(8); //green
	m_colors.push_back(9); //blue
	m_colors.push_back(11); //magenta
	m_colors.push_back(12); //yellow
	m_colors.push_back(10); //cyan
	m_colors.push_back(13); //dark red
	m_colors.push_back(14); //dark green
	m_colors.push_back(15); //dark blue
}
void MyGraphicsView::activeZoomIn(bool checked){
	if (checked){
		m_zoomInActivated = true;
		QCursor m_zoomIn = QPixmap("C:/Users/Nico/Documents/Visual Studio 2012/Projects/ImageProcessing/Win32/Debug/zoomin.png");
		setCursor(QCursor(m_zoomIn));	
	}
	else {
		m_zoomInActivated = false;
		setCursor(Qt::ArrowCursor);
	}
}
void MyGraphicsView::activeZoomOut(bool checked){
	if (checked){
		m_zoomOutActivated = true;
		QCursor m_zoomOut = QPixmap("C:/Users/Nico/Documents/Visual Studio 2012/Projects/ImageProcessing/Win32/Debug/zoomout.png");
		setCursor(QCursor(m_zoomOut));	
	}
	else {
		setCursor(Qt::ArrowCursor);
		m_zoomOutActivated = false;
	}

}
void MyGraphicsView::activeZoomZone(bool checked){
	if (checked){
		m_zoomZoneActivated = true;
		QCursor m_zoomIn = QPixmap("C:/Users/Nico/Documents/Visual Studio 2012/Projects/ImageProcessing/Win32/Debug/zoomin.png");
		setCursor(QCursor(m_zoomIn));	
	}
	else {
		setCursor(Qt::ArrowCursor);
		m_zoomZoneActivated = false;
	}

}
void MyGraphicsView::mouseReleaseEvent(QMouseEvent *event){

	int valScrollX = horizontalScrollBar()->value();
	int valScrollY = verticalScrollBar()->value();
	
	if (m_zoomInActivated){
		QPoint cursorPosition = mapFromGlobal(QCursor::pos());

		int centerX = width()/2;
		int centerY = height()/2;
		
		scale(1.25,1.25);


		horizontalScrollBar()->setValue(1.25*valScrollX+(1.25*cursorPosition.x()-centerX));
		verticalScrollBar()->setValue(1.25*valScrollY+(1.25*cursorPosition.y()-centerY));

	


	}
	if (m_zoomOutActivated){
		int maxScrollBeforeX = horizontalScrollBar()->maximum();
		int maxScrollBeforeY = verticalScrollBar()->maximum();

		scale(1/1.25,1/1.25);

		int maxScrollAfterX = horizontalScrollBar()->maximum();
		int maxScrollAfterY = verticalScrollBar()->maximum();

		if (maxScrollBeforeX != 0){
			horizontalScrollBar()->setValue(valScrollX*(double)maxScrollAfterX/maxScrollBeforeX);
		}
		if (maxScrollBeforeY !=0){
			verticalScrollBar()->setValue(valScrollY*(double)maxScrollAfterX/maxScrollBeforeX);
		}
	}

	if(m_selectPaternActivated && m_initialization){
		QPointF init = m_cursorPositionInitScene;
		QPointF end = m_cursorPositionEndScene;
		emit paternCoordinates(init,end);
		m_initialization = false;
	}
	if(m_selectSearchingZoneActivated && m_initialization){
		delete m_selectionZone;
		for (int i(0);i<m_selectionPatternZones.size();i++){
			m_selectionPatternZones[i]->hide();
		}
		QPointF init = m_cursorPositionInitScene;
		QPointF end = m_cursorPositionEndScene;
		emit paternCoordinates(init,end);
		m_initialization = false;
	}

	if (m_zoomZoneActivated ){
		m_selectionZone->hide();

		int zoneWidth = abs(m_cursorPositionMoved.x()-m_cursorPositionInit.x());
		int zoneHeight = abs(m_cursorPositionMoved.y()-m_cursorPositionInit.y());

		if(zoneWidth>20 && zoneHeight>20){

			int centerX = width()/2;
			int centerY = height()/2;
			int leftPointX(0);
			int leftPointY(0);
		
			if (m_cursorPositionInit.x()<m_cursorPositionMoved.x()){ 
				leftPointX = m_cursorPositionInit.x();
			}
			else {
				leftPointX = m_cursorPositionMoved.x();
			}
			if (m_cursorPositionInit.y()<m_cursorPositionMoved.y()){ 
				leftPointY = m_cursorPositionInit.y();
			}
			else {
				leftPointY = m_cursorPositionMoved.y();
			}
	

			if (zoneWidth>zoneHeight){
			
				double scaleFactor = (double)width()/zoneWidth;
				scale(scaleFactor,scaleFactor);
				valScrollX = horizontalScrollBar()->value();
				valScrollY = verticalScrollBar()->value();
				horizontalScrollBar()->setValue(valScrollX+scaleFactor*(leftPointX+(double)zoneWidth/2-centerX));
				verticalScrollBar()->setValue(valScrollY+scaleFactor*(leftPointY+(double)zoneHeight/2-centerY));
			}

			else{
				double scaleFactor = (double)height()/zoneHeight;
				scale(scaleFactor,scaleFactor);
				valScrollX = horizontalScrollBar()->value();
				valScrollY = verticalScrollBar()->value();
				horizontalScrollBar()->setValue(valScrollX+scaleFactor*(leftPointX+(double)zoneWidth/2-centerX));
				verticalScrollBar()->setValue(valScrollY+scaleFactor*(leftPointY+(double)zoneHeight/2-centerY));
			}
		}
	}

}
void MyGraphicsView::mousePressEvent(QMouseEvent *event){
	m_cursorPositionInit = mapFromGlobal(QCursor::pos());
	setToolTip(QString::number(m_cursorPositionInit.x()));

	if (m_selectPaternActivated){
		if(mapToScene(event->pos()).x()>0 && mapToScene(event->pos()).x()<m_dimx+1 &&
			mapToScene(event->pos()).y()>0 && mapToScene(event->pos()).y()<m_dimy+1){
				m_cursorPositionInitScene =  mapToScene(event->pos());
				m_cursorPositionEndScene = mapToScene(event->pos());
				m_cursorPositionInit = mapFromGlobal(QCursor::pos());
				m_selectionPatternZones.push_back(new QRubberBand(QRubberBand::Rectangle,this));
				m_selectionPatternZones[m_selectionPatternZones.size()-1]->move(m_cursorPositionInit.x(),m_cursorPositionInit.y());
				m_cursorPositionMoved = mapFromGlobal(QCursor::pos());
				m_initialization = true;
				QPalette pal;
				pal.setBrush(QPalette::Highlight, QBrush(Qt::GlobalColor(m_colors[m_selectionPatternZones.size()-1])));
				m_selectionPatternZones[m_selectionPatternZones.size()-1]->setPalette(pal);
		}
	}

		if (m_selectSearchingZoneActivated){
		if(mapToScene(event->pos()).x()>0 && mapToScene(event->pos()).x()<m_dimx+1 &&
			mapToScene(event->pos()).y()>0 && mapToScene(event->pos()).y()<m_dimy+1){
				m_cursorPositionInitScene =  mapToScene(event->pos());
				m_cursorPositionEndScene = mapToScene(event->pos());
				m_cursorPositionInit = mapFromGlobal(QCursor::pos());
				m_selectionZone = new QRubberBand(QRubberBand::Rectangle,this);
				m_selectionZone->move(m_cursorPositionInit.x(),m_cursorPositionInit.y());
				m_cursorPositionMoved = mapFromGlobal(QCursor::pos());
				m_initialization = true;
		}
	}

	if (m_zoomZoneActivated){

		m_cursorPositionInit = mapFromGlobal(QCursor::pos());
		m_selectionZone = new QRubberBand(QRubberBand::Rectangle,this);
		m_selectionZone->move(m_cursorPositionInit.x(),m_cursorPositionInit.y());
		m_cursorPositionMoved = mapFromGlobal(QCursor::pos());
	}

}
void MyGraphicsView::mouseMoveEvent(QMouseEvent *event){

	if (m_selectPaternActivated && m_initialization){
				
		if(mapToScene(event->pos()).x()>0 && mapToScene(event->pos()).x()<m_dimx+1 &&
		mapToScene(event->pos()).y()>0 && mapToScene(event->pos()).y()<m_dimy+1){
			m_cursorPositionMoved = mapFromGlobal(QCursor::pos());
			if(m_cursorPositionInit.x()<m_cursorPositionMoved.x()){
				if(m_cursorPositionInit.y()<m_cursorPositionMoved.y()){
					m_selectionPatternZones[m_selectionPatternZones.size()-1]->resize(m_cursorPositionMoved.x()-m_cursorPositionInit.x(),m_cursorPositionMoved.y()-m_cursorPositionInit.y());
					m_selectionPatternZones[m_selectionPatternZones.size()-1]->show();
					m_cursorPositionEndScene = mapToScene(event->pos());
				}
			
			}
		}
	}

	if (m_selectSearchingZoneActivated && m_initialization){
		if(mapToScene(event->pos()).x()>0 && mapToScene(event->pos()).x()<m_dimx+1 &&
		mapToScene(event->pos()).y()>0 && mapToScene(event->pos()).y()<m_dimy+1){
			m_cursorPositionMoved = mapFromGlobal(QCursor::pos());
			if(m_cursorPositionInit.x()<m_cursorPositionMoved.x()){
				if(m_cursorPositionInit.y()<m_cursorPositionMoved.y()){
					m_selectionZone->resize(m_cursorPositionMoved.x()-m_cursorPositionInit.x(),m_cursorPositionMoved.y()-m_cursorPositionInit.y());
				}
			m_selectionZone->show();
			m_cursorPositionEndScene = mapToScene(event->pos());
			}
		}
	}
	
	if (m_zoomZoneActivated){
		
		m_cursorPositionMoved = mapFromGlobal(QCursor::pos());
		if(m_cursorPositionInit.x()<m_cursorPositionMoved.x()){
			if(m_cursorPositionInit.y()<m_cursorPositionMoved.y()){
				m_selectionZone->resize(m_cursorPositionMoved.x()-m_cursorPositionInit.x(),m_cursorPositionMoved.y()-m_cursorPositionInit.y());
			}
			else{
				m_selectionZone->resize(m_cursorPositionMoved.x()-m_cursorPositionInit.x(),m_cursorPositionInit.y()-m_cursorPositionMoved.y());
				m_selectionZone->move(m_cursorPositionInit.x(),m_cursorPositionMoved.y());
			}
		}
		else{
			if(m_cursorPositionInit.y()<m_cursorPositionMoved.y()){
				m_selectionZone->resize(m_cursorPositionInit.x()-m_cursorPositionMoved.x(),m_cursorPositionMoved.y()-m_cursorPositionInit.y());
				m_selectionZone->move(m_cursorPositionMoved.x(),m_cursorPositionInit.y());
			}
			else{
				m_selectionZone->resize(m_cursorPositionInit.x()-m_cursorPositionMoved.x(),m_cursorPositionInit.y()-m_cursorPositionMoved.y());
				m_selectionZone->move(m_cursorPositionMoved.x(),m_cursorPositionMoved.y());
			}
		}
		m_selectionZone->show();
	

		
	
	}

}
void MyGraphicsView::activePaternSelection(bool checked){
	m_selectPaternActivated = checked;
}
void MyGraphicsView::activeSearchingSelection(bool checked){
	m_selectSearchingZoneActivated=checked;
}
void MyGraphicsView::deleteRubbers(){
	for (int i(0); i<m_selectionPatternZones.size();i++){
		delete m_selectionPatternZones[i];
	}
		m_selectionPatternZones.clear();
}