#ifndef DEF_MYGRAPHICSVIEW
#define DEF_MYGRAPHICSVIEW

#include <QtWidgets>
#include <math.h>


class MyGraphicsView: public QGraphicsView{

Q_OBJECT
public:
	MyGraphicsView(int dimx,int dimy);
	void mouseReleaseEvent(QMouseEvent *event);
	void mousePressEvent(QMouseEvent *event);
	void mouseMoveEvent(QMouseEvent *event);
	void deleteRubbers();


public slots:
	void activeZoomIn(bool checked);
	void activeZoomOut(bool checked);
	void activeZoomZone(bool checked);
	void activePaternSelection(bool checked);
	void activeSearchingSelection(bool checked);

signals:
	void paternCoordinates(QPointF init,QPointF end);

private:
	bool m_zoomInActivated;
	bool m_zoomOutActivated;
	bool m_zoomZoneActivated;
	QPoint m_cursorPositionInit;
	QPoint m_cursorPositionMoved;
	QRubberBand *m_selectionZone;
	QVector<QRubberBand*> m_selectionPatternZones;
	bool m_selectPaternActivated;
	QPointF	m_cursorPositionInitScene;
	QPointF m_cursorPositionEndScene;
	QPointF m_cursorPositionMovedPatern;
	int m_dimx;
	int m_dimy;
	bool m_initialization;
	bool m_selectSearchingZoneActivated;
	QVector<int> m_colors;




};






#endif //DEF_MYGRAPHICSVIEW