#include "MyQWTPlot.h"

MyQWTPlot::MyQWTPlot(){
	setFixedHeight(170);
	setFixedWidth(200);
	setAxisFont(0,QFont("Helvetica [Cronyx]",6));
	setAxisFont(2,QFont("Helvetica [Cronyx]",6));
	setAutoReplot(true);
	setAxisAutoScale(0,true);
	setAxisAutoScale(2,true);
}
void MyQWTPlot::addHistogram(QVector<double> histogram,int color,int neighborhood){
	QwtPlotCurve *curve = new QwtPlotCurve();
    curve->setPen(Qt::GlobalColor(color), 1 ),
    curve->setRenderHint( QwtPlotItem::RenderAntialiased, true );
	QVector<QPointF> pointsVector;
	int d = pow(2,pow(neighborhood,2)-1);
	QPolygonF points;
	for (int i(0);i<pow(2,16)+1;i++){
		pointsVector<<QPointF(i,histogram[i]);
	}
	points = pointsVector;
    curve->setSamples(points);
	curve->attach(this);

	m_curves.push_back(curve);
}
void MyQWTPlot::addGaussian(double* data, int color){
	this->detachItems();
	QwtPlotCurve *normalCurve = new QwtPlotCurve();
	normalCurve->setPen(Qt::GlobalColor(color), 1 ),
    normalCurve->setRenderHint( QwtPlotItem::RenderAntialiased, true );
	QPolygonF pointsNormalCurve;
	for (int i(0);i<256;i++){
		pointsNormalCurve << QPointF(i,1/(data[1]*sqrt(2*M_PI))*exp(-pow(((double)i-data[0])/data[1],2)/2));
	}
	
	normalCurve->setSamples(pointsNormalCurve);
	normalCurve->attach(this);
}
void MyQWTPlot::setVisibleQwtCurve(bool checked,int curveNumber){
	m_curves[curveNumber]->setVisible(checked);
}
void MyQWTPlot::reset(){
	m_curves.clear();
	this->detachItems();
}
