#ifndef DEF_OPENEDFILE
#define DEF_OPENEDFILE

#include <QtWidgets>
#include "hdf.h"
#include <opencv2/highgui/highgui.hpp>
#include <opencv/cv.h>
#include "MyGraphicsView.h"


class OpenedFile{

public:
	OpenedFile(QMainWindow *context,QString type,QString fileName,int sd_id,uint16 **data,int32 *dimsize); //For SDS
	OpenedFile(QMainWindow *context,QString type, uint16 **dataR,uint16 **dataG, uint16 **dataB, int32 *dimsize); //For RGB
	OpenedFile(QMainWindow *context,QString type, QString fileName);
	OpenedFile(cv::Mat mat);
	cv::Mat uint16ToMat(uint16 **data,int32 dimsize[2],QString band);
	QImage matToQImage(cv::Mat mat);
	QGraphicsScene* createGraphicsScene(QImage image);
	MyGraphicsView* createGraphicsView(QGraphicsScene* scene,int32 *dimsize);
	MyGraphicsView* getGraphicsView();
	int getID();
	QString getFileName();
	QString getType();
	void modifyMat(int contrast, int luminosity, cv::Mat);
	cv::Mat getMat();
	int getContrast();
	int getLuminosity();
	cv::Mat OpenedFile::toRGBMat(cv::Mat matR,cv::Mat matG,cv::Mat matB,int32 *dimsize);
	cv::Mat getModifiedMat();
	void setClassifiedMat(cv::Mat mat);
	void resetMat();

private:
	QMainWindow *m_context;
	QString m_type;
	QString m_fileName;
	int m_sd_id;
	int32 *m_dimsize;
	cv::Mat m_mat;
	cv::Mat m_modifiedMat;
	cv::Mat m_classifiedMat;
	QGraphicsScene *m_scene;
	MyGraphicsView *m_view;
	QLabel *m_taskLabel;
	QProgressBar *m_progressBar;
	int m_contrast;
	int m_luminosity;


};



#endif
