#ifndef DEF_PROCESSINGFUNCTIONS
#define DEF_PROCESSINGFUNCTIONS

#include <opencv2/highgui/highgui.hpp>
#include <opencv/cv.h>
#include <QtWidgets>
#include <vector>
#include <math.h>
#include "MyGraphicsView.h"
#include "MatrixFunctions.h"

class ProcessingFunctions{
public: 
	static cv::Mat contrast(QMainWindow *context,cv::Mat matImage, double alpha,double beta);
	static QImage conversionToQImage(cv::Mat matImage);
	static QVector<double> LBPCalculRef(cv::Mat modifiedMat,QPointF init,QPointF end, int neighborhood,int middle);
	static void GMRFCalculRefMean(cv::Mat mat,int neighborhood,double *mean);
	static void GMRFCalculRefMatrix(cv::Mat mat,int neighborhood,double* mean,double **inverseMatrix);
	static cv::Mat LBPClassifier(QMainWindow *context, cv::Mat modifiedMat,QPointF init,QPointF end, QVector<QVector<double>> features,QVector<QVector<double>> featuresNormal, bool colorsType,int neighborhood,int middle,bool test);
	static cv::Mat GMRFClassifier(QMainWindow *context, cv::Mat modifiedMat,QPointF init,QPointF end,QVector<double*> featuresMean, QVector<double**> featuresMatrix, bool colorsType,int neighborhood,int middle,bool test);
	static cv::Mat refLabel();
	static int** createMatrixLabel();
	static int* switchColorize(int label, bool colorsType);
	static int* neignborhoodAndMiddle(int neighborsChoice);
	static double indexMeanCalcul(QVector<double> index,int neighborhood);
	static int lbpIndexCalcul(int i, int j,int neighborhood,int middle, cv::Mat modifiedMat);
	static double* histogramToGaussian(double *histogram);

};



#endif